const Wait = require('./wait');

function waitElementVisible(page, elementSelector) {
  const wait = new Wait(page, elementSelector);
  wait.waitElementVisible();
}

const ExpectElement = require('./expect');

class Checkbox {
  constructor(page, elementSelector, value) {
    this.page = page;
    this.elementSelector = elementSelector;
    this.value = value;
    this.valueIndexSelector = `${this.elementSelector}>input[value='${this.value}']`;
  }

  selectCheckbox() {
    waitElementVisible(this.page, this.elementSelector);
    this.page.click(this.elementSelector);
  }

  selectCheckboxByValue() {
    waitElementVisible(this.page, this.elementSelector);
    return this.page.click(this.elementSelector, () => {
      if (this.value === '' || this.value === undefined) {
        this.page.click(`${this.elementSelector}>input[value]`);
      } else {
        this.page.click(this.valueIndexSelector);
      }
    });
  }

  expectCheckboxSelected() {
    const expectElement = new ExpectElement(this.page, this.elementSelector);
    expectElement.expectElementSelected();
  }

  expectCheckboxSelectedValue() {
    this.page.getValue(this.elementSelector, (result) => {
      this.page.assert.equal(result.value, this.value);
      this.expectCheckboxSelected();
    });
  }
}

module.exports = Checkbox;
