/* eslint no-useless-escape: off */

const Wait = require('./wait');

function waitElementVisible(page, elementSelector) {
  const wait = new Wait(page, elementSelector);
  wait.waitElementVisible();
}

class Dropdown {
  constructor(page, elementSelector, selectedOption) {
    this.page = page;
    this.elementSelector = elementSelector;
    this.selectedOption = selectedOption;
    this.valueIndexSelector = `${this.elementSelector}>option[value='${this.selectedOption}']`;
    this.valueClassSelector = `${this.elementSelector}>option[class='${this.selectedOption}']`;
  }

  isDropdown() {
    return this.page.expect.element(this.elementSelector).to.be.a('select');
  }

  chooseOptionValue() {
    this.isDropdown();
    return this.page.click(this.elementSelector, () => {
      if (this.selectedOption === '' || this.selectedOption === undefined) {
        this.page.click(`${this.elementSelector}>option[value]`);
      } else {
        waitElementVisible(this.page, this.valueIndexSelector);
        this.page.click(this.valueIndexSelector);
      }
    });
  }

  chooseOptionClass() {
    return this.page.click(this.elementSelector, () => {
      if (this.selectedOption === '') {
        this.page.click(`${this.elementSelector}>option[class]`);
      } else {
        waitElementVisible(this.page, this.valueClassSelector);
        this.page.click(this.valueClassSelector);
      }
    });
  }
}

module.exports = Dropdown;
