class ExpectElement {
  constructor(page, elementSelector, time) {
    this.page = page;
    this.elementSelector = elementSelector;
    this.time = time;
  }

  expectElementVisible() {
    return this.page.expect.element(this.elementSelector).to.be.visible;
  }

  expectElementNotVisible() {
    return this.page.expect.element(this.elementSelector).to.not.be.visible;
  }

  expectElementVisibleBeforeTime() {
    return this.page.expect.element(this.elementSelector).to.be.visible.before(this.time);
  }

  expectElementPresent() {
    return this.page.expect.element(this.elementSelector).to.be.present;
  }

  expectElementNotPresent() {
    return this.page.expect.element(this.elementSelector).to.not.be.present;
  }

  expectElementPresentBeforeTime() {
    return this.page.expect.element(this.elementSelector).to.be.present.before(this.time);
  }

  expectElementEnabled() {
    return this.page.expect.element(this.elementSelector).to.be.enabled;
  }

  expectElementNotEnabled() {
    return this.page.expect.element(this.elementSelector).to.not.be.enabled;
  }

  expectElementEnabledBeforeTime() {
    return this.page.expect.element(this.elementSelector).to.be.enabled.before(this.time);
  }

  expectElementSelected() {
    return this.page.expect.element(this.elementSelector).to.be.selected;
  }

  expectElementNotSelected() {
    return this.page.expect.element(this.elementSelector).to.not.be.selected;
  }

  expectElementSelectedBeforeTime() {
    return this.page.expect.element(this.elementSelector).to.be.selected.before(this.time);
  }
}

module.exports = ExpectElement;
