const TextField = require('./text-field');

function clickTextField(page, elementSelector) {
  const textField = new TextField(page, elementSelector);
  textField.clearTextField();
  textField.clickTextField();
}

class Keyboard {
  constructor(page, elementSelector, words) {
    this.page = page;
    this.elementSelector = elementSelector;
    this.words = words;
  }

  keyboardPress() {
    const typedWords = Array.from(this.words);
    return typedWords.forEach(value => this.page.keys(value));
  }

  keyboardPresswithDelay() {
    const typedWords = Array.from(this.words);
    return typedWords.forEach((value) => {
      this.page.pause(500);
      return this.page.keys(value);
    });
  }

  keyboardPressOnTextField() {
    clickTextField(this.page, this.elementSelector);
    this.keyboardPress();
  }

  keyboardPresswithDelayOnTextField() {
    clickTextField(this.page, this.elementSelector);
    this.keyboardPresswithDelay();
  }

  keyboardPressOnOthers() {
    this.page.click(this.elementSelector);
    this.keyboardPress();
  }

  keyboardPresswithDelayOnOthers() {
    this.page.click(this.elementSelector);
    this.keyboardPresswithDelay();
  }
}

module.exports = Keyboard;
