class LinkText {
  constructor(page, elementSelector, textElement) {
    this.page = page;
    this.elementSelector = elementSelector;
    this.textElement = textElement;
    this.wordFound = [];
  }

  isLinkText() {
    return this.page.expect.element(this.elementSelector).to.be.an('a');
  }

  isNotLinkText() {
    return this.page.expect.element(this.elementSelector).to.not.be.an('a');
  }

  assertLinkTextContainsText() {
    this.isLinkText();
    return this.page.assert.containsText(this.elementSelector, this.expectedText);
  }

  clickLinkText() {
    this.isLinkText();
    this.page.click(this.elementSelector);
  }

  clickLinkByText() {
    this.page.elements('css selector', this.elementSelector, (result) => {
      Object.keys(result.value).forEach((key) => {
        this.page.elementIdText(result.value[key].ELEMENT, (res) => {
          if (this.textElement === res.value) {
            this.page.elementIdClick(result.value[key].ELEMENT);
            this.wordFound.push(res.value);
          }
        });
      });
    });
    this.page.perform(() => {
      if (this.wordFound.length === 0) {
        throw new Error(`clickLinkByText - Element ${this.elementSelector} with text: ${this.textElement} is NOT FOUND`);
      } else if (this.wordFound.length > 1) {
        throw new Error(`clickLinkByText - Element ${this.elementSelector} with text: ${this.textElement} has 2 or more entries`);
      }
    });
  }
}

module.exports = LinkText;
