class TextField {
  constructor(page, elementSelector, value, expectedValue, browser) {
    this.page = page;
    this.elementSelector = elementSelector;
    this.value = value;
    this.expectedValue = expectedValue;
    this.browser = browser;
  }

  isTextField() {
    return this.page.expect.element(this.elementSelector).to.be.an('input');
  }

  isNotTextField() {
    return this.page.expect.element(this.elementSelector).to.not.be.an('input');
  }

  clearTextField() {
    this.page.clearValue(this.elementSelector);
  }

  clickTextField() {
    this.page.click(this.elementSelector);
  }

  setValueTextField() {
    this.isTextField();
    this.clearTextField();
    this.clickTextField();
    this.page.setValue(this.elementSelector, this.value);
  }

  setValueTextFieldThenEnter() {
    this.page.clearValue(this.elementSelector, () => {
      this.page.click(this.elementSelector, () => {
        this.page.setValue(this.elementSelector, [this.value, this.browser.Keys.ENTER]);
      });
    });
  }

  expectEqualsValue() {
    this.isTextField();
    return this.page.expect.element(this.elementSelector).to.have.value.that.equals(this.expectedValue);
  }

  expectNotEqualsValue() {
    this.isTextField();
    return this.page.expect.element(this.elementSelector).to.have.value.not.equals(this.expectedValue);
  }

  expectContainsValue() {
    this.isTextField();
    return this.page.expect.element(this.elementSelector).to.have.value.which.contains(this.expectedValue);
  }
}

module.exports = TextField;
