/* eslint no-unused-vars: off */
/* eslint no-console: off */

const seleniumServerPath = './node_modules/selenium-server/lib/runner/selenium-server-standalone-3.4.0.jar';
const chromedriverPath = './node_modules/chromedriver/lib/chromedriver/chromedriver';
const geckodriverPath = './node_modules/geckodriver/geckodriver';
const cmd = require('node-cmd');
const fs = require('fs');

function downloadDriver(modules) {
  cmd.get(`npm install ${modules}`, (err, data, stderr) => {
    console.log(data);
    console.log(stderr);
    if (err !== null) {
      cmd.get(`npm install ${modules} --save-dev`, (errif, dataif, stderrif) => {
        console.log(dataif);
        console.log(stderrif);
      });
    }
  });
}

function checkChromeDriver() {
  console.log('Checking Chromedriver');
  fs.stat(chromedriverPath, (err, stat) => {
    if (err || !stat || stat.size < 1) {
      console.log('Downloading Chromedriver');
      downloadDriver('chromedriver');
    } else {
      console.log(`Chromedriver is available at: ${chromedriverPath}`);
    }
  });
}

function checkGeckoDriver() {
  console.log('Checking Geckodriver');
  fs.stat(geckodriverPath, (err, stat) => {
    if (err || !stat || stat.size < 1) {
      console.log('Downloading Geckodriver');
      downloadDriver('geckodriver');
    } else {
      console.log(`Geckodriver is available at: ${geckodriverPath}`);
    }
  });
}

function checkSeleniumServer() {
  console.log('Checking Selenium Server');
  fs.stat(seleniumServerPath, (err, stat) => {
    if (err || !stat || stat.size < 1) {
      console.log('Downloading Selenium Server');
      downloadDriver('selenium-server@3.4.0');
    } else {
      console.log(`Selenium Server is available at: ${seleniumServerPath}`);
    }
  });
}
